package ai.pai.client.utils;


import com.android.common.http.HttpUtils;
import com.android.hotpatch.utils.IPatchManager;

import org.json.JSONObject;

import java.io.File;

import ai.pai.client.db.Preferences;

public class PatchManager extends IPatchManager{

    private String md5;

    public PatchManager(){
        new File(Constants.APP_PATCH_DIR).mkdirs();
    }

    @Override
    protected String getPatchFileDownloadUrl(String patchConfigUrl) {
        String jsonStr = HttpUtils.doHttpPost(patchConfigUrl,null);
        try{
            JSONObject response = new JSONObject(jsonStr);
            md5 = response.getString("md5");
            return response.getString("patch_url");
        }catch (Exception e){
            e.printStackTrace();
        }
        return null;
    }

    @Override
    protected boolean isNewPatchFound() {
        if(!Preferences.getInstance(context).getPatchMD5().equals(md5)){
            return true;
        }
        if(!new File(patchSavePath).exists()){
            return true;
        }
        return false;
    }

    @Override
    protected void afterPatchSuccess() {
        Preferences.getInstance(context).setPatchMD5(md5);
    }
}
